VERSION 5.00
Begin VB.UserControl UDragList 
   BorderStyle     =   1  'Fixed Single
   ClientHeight    =   465
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   1245
   ScaleHeight     =   31
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   83
   ToolboxBitmap   =   "UDragList.ctx":0000
   Begin VB.ListBox lstDragList 
      Appearance      =   0  'Flat
      Height          =   450
      IntegralHeight  =   0   'False
      ItemData        =   "UDragList.ctx":0312
      Left            =   0
      List            =   "UDragList.ctx":0314
      TabIndex        =   0
      Top             =   0
      Width           =   1215
   End
End
Attribute VB_Name = "UDragList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
  Option Explicit
  ' demo project showing how to turn a VB listbox into a DragList
  ' using the API functions in the common controls library.
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.
  
  
  ' What Is A DragList?
  '
  ' From the Win32 SDK:
  ' A drag list box is a special type of list box that enables the
  ' user to drag items from one position to another. An application
  ' can use a drag list box to display strings in a particular
  ' sequence and allow the user to change the sequence.

    
  ' IMPORTANT NOTE:
  ' if you have the MS Debug Object on your system, add a reference to it
  ' in the references dialog and change the value of DEBUGWINDOWPROC to -1
  ' in the Conditional Compiliation Arguments field on the Make tab of the
  ' project properties dialog.  Doing so will allow you to set break points
  ' in the code without crashing.  IF YOU DO NOT HAVE THE DEBUG OBJECT, DO
  ' NOT ENTER BREAK MODE IN THE VB IDE!!!  If you do, you will probably
  ' CRASH!!!
  #If DEBUGWINDOWPROC Then
    Private m_DWPHook As WindowProcHook
  #End If
  
  ' holds the address to the original window proc for the usercontrol
  Private m_WinProcOld As Long

  ' used to keep track of whether we are in design or run mode
  Private m_fDesign As Boolean
  
  
  ' structs, constants and API functions from the common controls library
  Private Type DRAGLISTINFO
    uNotification As Long
    hWnd As Long
    ptCursor As POINTL
  End Type
  
  Private Const DRAGLISTMSGSTRING As String = "commctrl_DragListMsg"
  
  Private Const DL_BEGINDRAG As Long = (WM_USER + 133&)
  Private Const DL_DRAGGING As Long = (WM_USER + 134&)
  Private Const DL_DROPPED As Long = (WM_USER + 135&)
  Private Const DL_CANCELDRAG As Long = (WM_USER + 136&)
  
  Public Enum DRAG_CURSOR_TYPE
    DL_STOPCURSOR = 1&
    DL_COPYCURSOR = 2&
    DL_MOVECURSOR = 3&
  End Enum
  
  Private Declare Function MakeDragList Lib "comctl32" (ByVal hWndLB&) As Long
  Private Declare Function LBItemFromPt Lib "comctl32" (ByVal hWndLB&, ByVal ptX&, ByVal ptY&, ByVal bAutoScroll&) As Long
  Private Declare Sub DrawInsert Lib "comctl32" (ByVal hWndParent&, ByVal hWndLB&, ByVal nItem&)
  
  ' holds the message value for this returned from RegisterWindowMessage.
  ' the value is the message we subclass to get the drag info from the drag list
  Private m_nDRAGLISTMSGSTRING As Long
  
  
  ' events passed out from the VB listbox.  some events have to be renamed because of
  ' conflicts with the events of the usercontrol.  also, some properties of the listbox
  ' cannot be set because the listbox is in runtime when in the user control.  however,
  ' a draglist cannot be multi select so the only real change that might be necessary
  ' would be if you wanted your list to be sorted.  that would sort of defeat the purpose
  ' of being able to reorder items though so it shouldn't be a problem in most situations
  Event Click()
  Event DblClick()
  Event LBDragDrop(Source As Object, x As Single, y As Single)
  Event LBDragOver(Source As Object, x As Single, y As Single, State As Integer)
  Event LBGotFocus()
  Event KeyDown(KeyCode As Integer, Shift As Integer)
  Event KeyPress(KeyAscii As Integer)
  Event KeyUp(KeyCode As Integer, Shift As Integer)
  Event LBLostFocus()
  Event MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  Event OLECompleteDrag(Effect As Long)
  Event OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
  Event OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
  Event OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
  Event OLESetData(Data As DataObject, DataFormat As Integer)
  Event OLEStartDrag(Data As DataObject, AllowedEffects As Long)
  Event Scroll()

  ' custom events associated with the draglist implementation
  Event DLBeginDrag(ByVal iItem&, ByVal x&, ByVal y&, ByRef bCancel As Boolean)
  Event DLDragging(ByVal iItem&, ByVal x&, ByVal y&, ByRef CursorType As DRAG_CURSOR_TYPE, ByRef bNoInsertIcon As Boolean)
  Event DLDropped(ByVal iItem&, ByVal x&, ByVal y&)
  Event DLDragCanceled()

Friend Function DragListProc(ByVal hWnd&, ByVal uMsg&, ByVal wParam&, ByVal lParam&) As Long

  ' our message handler.  we process the drag messages here
  
  Select Case uMsg ' if the message is a draglist message, copy the struct pointed to by
    Case m_nDRAGLISTMSGSTRING ' lParam into our local DRAGLISTINFO struct
    
      Dim lpDLI As DRAGLISTINFO, bCancel As Boolean, nItem&
    
      CopyMemory ByVal VarPtr(lpDLI), ByVal lParam, Len(lpDLI)
      
      With lpDLI ' then take the appropriate action depending on the message
        Select Case .uNotification
          Case DL_BEGINDRAG  ' begin dragging...
            
            ' get the item and pass API_TRUE to enable the "autoscroll" feature when the cursor is above or below the list
            nItem = LBItemFromPt(lstDragList.hWnd, .ptCursor.x, .ptCursor.y, API_TRUE)
            
            ' raise our custom event and pass bCancel ByRef to allow the drag to be canceled
            RaiseEvent DLBeginDrag(nItem, .ptCursor.x, .ptCursor.y, bCancel)
            
            If bCancel Then ' return the appropriate value
              DragListProc = API_FALSE
            Else
              DragListProc = API_TRUE
            End If
            
            Exit Function
            
            
          Case DL_DRAGGING ' in a drag operation....
            Dim eCursorType As DRAG_CURSOR_TYPE
            
            ' get the item and pass API_TRUE to enable the "autoscroll" feature when the cursor is above or below the list
            nItem = LBItemFromPt(lstDragList.hWnd, .ptCursor.x, .ptCursor.y, API_TRUE)
            
            ' raise our custom event and allow the "insert arrow" icon to be erased by passing bCancel ByRef
            RaiseEvent DLDragging(nItem, .ptCursor.x, .ptCursor.y, eCursorType, bCancel)
            
            ' if they don't want to show the icon....
            If bCancel Then nItem = (-1)
            
            ' call the function to draw the insert icon.  if nItem is a list item, the insert
            ' will be drawn above the item.  if it is (-1), the icon will be erased
            Call DrawInsert(GetParent(UserControl.hWnd), lstDragList.hWnd, nItem)
            
            ' return the type of cursor we want displayed.  the options are: DL_STOPCURSOR,
            ' DL_COPYCURSOR and DL_MOVECURSOR.  any other value will draw the default cursor
            DragListProc = eCursorType
            
            Exit Function
            
            
          Case DL_DROPPED ' item was dropped....
            
            ' get the item....
            nItem = LBItemFromPt(lstDragList.hWnd, .ptCursor.x, .ptCursor.y, API_TRUE)

            ' raise our custom event
            RaiseEvent DLDropped(nItem, .ptCursor.x, .ptCursor.y)
            
            ' erase the insert icon
            Call DrawInsert(GetParent(UserControl.hWnd), lstDragList.hWnd, (-1&))
            
            ' this message does not return a value
            Exit Function
            
            
          Case DL_CANCELDRAG ' operation was canceled....
          
            ' rais the event to allow any needed "state" clean up in the client
            RaiseEvent DLDragCanceled
            
            ' erase the insert icon
            Call DrawInsert(GetParent(UserControl.hWnd), lstDragList.hWnd, (-1&))
          
            ' this message does not return a value
            Exit Function
            
        End Select
    End With
    
  End Select
  
  ' pass all other messages on to the original window proc
  DragListProc = CallWindowProc(m_WinProcOld, hWnd, uMsg, wParam, lParam)
  
End Function

Public Sub Refresh()
  UserControl.Refresh
  lstDragList.Refresh
End Sub

Private Sub UserControl_AmbientChanged(PropertyName As String)
  If m_fDesign Then
    If PropertyName = "DisplayName" Then SetDisplayName
  End If
End Sub

Private Sub SetDisplayName()
  With lstDragList
    .Clear
    .AddItem UserControl.Ambient.DisplayName
  End With
End Sub

Private Sub UserControl_EnterFocus()
  lstDragList.SetFocus
End Sub

Private Sub SetLBStyles()
  Dim fStyles&
  
  With lstDragList
    fStyles = GetWindowLong(.hWnd, GWL_STYLE)
    
    ' remove the border from the listbox....
    If fStyles And WS_BORDER Then
      Call SetWindowLong(.hWnd, GWL_STYLE, fStyles Xor WS_BORDER)
      
      ' make the *&^&^$^&$&& thing redraw w/o the border
      '.Move 0, 0, .Width + 2
      '.Move 0, 0, .Width - 2
      
      'Call SetWindowPos(.hWnd, 0&, 0&, 0&, 0&, 0&, SWP_NOMOVE Or SWP_NOSIZE Or SWP_NOZORDER Or SWP_FRAMECHANGED)
    End If
  End With
  
End Sub

Private Sub UserControl_Resize()
  ' resize the listbox to fill the client area of the user control
  With UserControl
    lstDragList.Move 0, 0, .ScaleWidth, .ScaleHeight
  End With
End Sub

Private Sub InitializeDragList()
  ' calls required to create the draglist
  
  Static bListCreated As Boolean
  
  If bListCreated = False Then
    bListCreated = True
    
    SubClass
    
    Call MakeDragList(lstDragList.hWnd)
    
    m_nDRAGLISTMSGSTRING = RegisterWindowMessage(DRAGLISTMSGSTRING)
  End If
End Sub

Private Sub UserControl_Terminate()
  UnSubClass
End Sub

Private Sub UserControl_InitProperties()
  
  SetDesignMode
  SetLBStyles
  
  If Not m_fDesign Then
    InitializeDragList
  Else
    SetDisplayName
  End If
  
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)

  SetDesignMode
  SetLBStyles
  
  If Not m_fDesign Then
    InitializeDragList
  Else
    SetDisplayName
  End If

End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
  '
End Sub

Private Sub NoPropertySheet()
  'If you stop on this error, then right click on the
  'code pane and choose Toggle/Break on Unhandled Errors.
  'You can set the default for this setting in the Tools/Options
  'dialog on the General tab.
  If m_fDesign Then Err.Raise 394 'GetNotSupported
End Sub

Private Sub DesignTimeOnly()
  If Not m_fDesign Then Err.Raise 382
End Sub

Private Sub SetDesignMode()
  On Error Resume Next
  m_fDesign = Not Ambient.UserMode
  If Err Then m_fDesign = True
  Err.Clear
End Sub

Private Sub SubClass()

  Dim hWnd&
  
  hWnd = UserControl.hWnd
  
  UnSubClass

  If GetProp(hWnd, "nvDragLst") Then Exit Sub
  
  If SetProp(hWnd, ByVal "nvDragLst", ObjPtr(Me)) Then

    #If DEBUGWINDOWPROC Then
      Set m_DWPHook = CreateWindowProcHook
      With m_DWPHook
        .SetMainProc AddressOf MDragList.DrgLstProc
        m_WinProcOld = SetWindowLong(hWnd, GWL_WNDPROC, .ProcAddress)
        .SetDebugProc m_WinProcOld
      End With
    #Else
      m_WinProcOld = SetWindowLong(hWnd, GWL_WNDPROC, AddressOf MDragList.DrgLstProc)
    #End If
  End If
  
End Sub

Private Sub UnSubClass()

  Dim hWnd&

  If m_WinProcOld Then
    hWnd = UserControl.hWnd
    
    SetWindowLong hWnd, GWL_WNDPROC, m_WinProcOld
    RemoveProp hWnd, "nvDragLst"
    m_WinProcOld = 0
  End If
  #If DEBUGWINDOWPROC Then
    Set m_DWPHook = Nothing
  #End If
End Sub


' #############  Begin Properties and Methods  ##############
Public Sub AddItem(ByVal Item$, Optional ByVal Index% = (-1))
  NoPropertySheet
  
  If Index > (-1) Then
    lstDragList.AddItem Item, Index
  Else
    lstDragList.AddItem Item
  End If
End Sub

Public Property Get LBBackColor() As OLE_COLOR
  LBBackColor = lstDragList.BackColor
End Property
Public Property Let LBBackColor(ByVal nNewVal As OLE_COLOR)
  lstDragList.BackColor = nNewVal
End Property

Public Sub Clear()
  lstDragList.Clear
End Sub

Public Property Get LBFont() As StdFont
  NoPropertySheet
  Set LBFont = lstDragList.Font
End Property
Public Property Set LBFont(ByVal oNewVal As StdFont)
  NoPropertySheet
  Set lstDragList.Font = oNewVal
End Property

Public Property Get LBFontBold() As Boolean
  NoPropertySheet
  LBFontBold = lstDragList.FontBold
End Property
Public Property Let LBFontBold(ByVal bNewVal As Boolean)
  NoPropertySheet
  lstDragList.FontBold = bNewVal
End Property

Public Property Get LBFontItalic() As Boolean
  NoPropertySheet
  LBFontItalic = lstDragList.FontItalic
End Property
Public Property Let LBFontItalic(ByVal bNewVal As Boolean)
  NoPropertySheet
  lstDragList.FontItalic = bNewVal
End Property

Public Property Get LBFontName(ByVal Index%) As String
  NoPropertySheet
  LBFontName = lstDragList.FontName
End Property
Public Property Let LBFontName(ByVal Index%, ByVal sNewVal$)
  NoPropertySheet
  lstDragList.FontName = sNewVal
End Property

Public Property Get LBFontSize() As Single
  NoPropertySheet
  LBFontSize = lstDragList.FontSize
End Property
Public Property Let LBFontSize(ByVal sngNewVal!)
  NoPropertySheet
  lstDragList.FontSize = sngNewVal
End Property

Public Property Get LBFontStrikethru() As Boolean
  NoPropertySheet
  LBFontStrikethru = lstDragList.FontStrikethru
End Property
Public Property Let LBFontStrikethru(ByVal bNewVal As Boolean)
  NoPropertySheet
  lstDragList.FontStrikethru = bNewVal
End Property

Public Property Get LBFontUnderline() As Boolean
  NoPropertySheet
  LBFontUnderline = lstDragList.FontUnderline
End Property
Public Property Let LBFontUnderline(ByVal bNewVal As Boolean)
  NoPropertySheet
  lstDragList.FontUnderline = bNewVal
End Property

Public Property Get LBForeColor() As OLE_COLOR
  LBForeColor = lstDragList.ForeColor
End Property
Public Property Let LBForeColor(ByVal nNewVal As OLE_COLOR)
  lstDragList.ForeColor = nNewVal
End Property

Public Property Get HelpContextID() As Long
  HelpContextID = lstDragList.HelpContextID
End Property
Public Property Let HelpContextID(ByVal nNewVal&)
  lstDragList.HelpContextID = nNewVal
End Property

Public Property Get UChWnd() As Long
  UChWnd = UserControl.hWnd
End Property

Public Property Get LBhWnd() As Long
  LBhWnd = lstDragList.hWnd
End Property

Public Property Get IntegralHeight() As Boolean
  NoPropertySheet
  IntegralHeight = lstDragList.IntegralHeight
End Property

Public Property Get ItemData(ByVal Index%) As Long
  NoPropertySheet
  ItemData = lstDragList.ItemData(Index)
End Property
Public Property Let ItemData(ByVal Index%, ByVal nNewVal&)
  NoPropertySheet
  lstDragList.ItemData(Index) = nNewVal
End Property

Public Property Get List(ByVal Index%) As String
  NoPropertySheet
  List = lstDragList.List(Index)
End Property
Public Property Let List(ByVal Index%, ByVal sNewVal$)
  NoPropertySheet
  lstDragList.List(Index) = sNewVal
End Property

Public Property Get ListCount() As Integer
  NoPropertySheet
  ListCount = lstDragList.ListCount
End Property

Public Property Get ListIndex() As Integer
  NoPropertySheet
  ListIndex = lstDragList.ListIndex
End Property
Public Property Let ListIndex(ByVal nNewVal%)
  NoPropertySheet
  lstDragList.ListIndex = nNewVal
End Property

Public Property Get LBMouseIcon() As StdPicture
  Set LBMouseIcon = lstDragList.MouseIcon
End Property
Public Property Let LBMouseIcon(ByVal oNewVal As StdPicture)
  lstDragList.MouseIcon = oNewVal
End Property

Public Property Get LBMousePointer() As Integer
  LBMousePointer = lstDragList.MousePointer
End Property
Public Property Let LBMousePointer(ByVal nNewVal%)
  lstDragList.MousePointer = nNewVal
End Property

Public Property Get NewIndex() As Integer
  NoPropertySheet
  NewIndex = lstDragList.NewIndex
End Property

Public Sub LBOLEDrag()
  lstDragList.OLEDrag
End Sub

Public Property Get LBOLEDragMode() As Integer
  LBOLEDragMode = lstDragList.OLEDragMode
End Property
Public Property Let LBOLEDragMode(ByVal nNewVal%)
  lstDragList.OLEDragMode = nNewVal
End Property

Public Property Get LBOLEDropMode() As Integer
  LBOLEDropMode = lstDragList.OLEDropMode
End Property
Public Property Let LBOLEDropMode(ByVal nNewVal%)
  lstDragList.OLEDropMode = nNewVal
End Property

Public Sub RemoveItem(ByVal Index%)
  lstDragList.RemoveItem Index
End Sub

Public Property Get RightToLeft() As Boolean
  RightToLeft = lstDragList.RightToLeft
End Property
Public Property Let RightToLeft(ByVal bNewVal As Boolean)
  lstDragList.RightToLeft = bNewVal
End Property

Public Property Get SelCount() As Integer
  NoPropertySheet
  SelCount = lstDragList.SelCount
End Property

Public Property Get Selected(ByVal Index%) As Boolean
  NoPropertySheet
  Selected = lstDragList.Selected(Index)
End Property
Public Property Let Selected(ByVal Index%, ByVal bNewVal As Boolean)
  NoPropertySheet
  lstDragList.Selected(Index) = bNewVal
End Property

Public Sub ShowWhatsThis()
  lstDragList.ShowWhatsThis
End Sub

Public Property Get Sorted() As Boolean
  Sorted = lstDragList.Sorted
End Property

Public Property Get Style() As Integer
  NoPropertySheet
  Style = lstDragList.Style
End Property

Public Property Get Text() As String
  NoPropertySheet
  Text = lstDragList.Text
End Property
Public Property Let Text(ByVal sNewVal$)
  NoPropertySheet
  lstDragList.Text = sNewVal
End Property

Public Property Get LBToolTipText() As String
  LBToolTipText = lstDragList.ToolTipText
End Property
Public Property Let LBToolTipText(ByVal sNewVal$)
  lstDragList.ToolTipText = sNewVal
End Property

Public Property Get TopIndex() As Integer
  NoPropertySheet
  TopIndex = lstDragList.TopIndex
End Property
Public Property Let TopIndex(ByVal nNewVal%)
  NoPropertySheet
  lstDragList.TopIndex = nNewVal
End Property

Public Property Get LBWhatsThisHelpID() As Long
  LBWhatsThisHelpID = lstDragList.WhatsThisHelpID
End Property
Public Property Let LBWhatsThisHelpID(ByVal nNewVal&)
  lstDragList.WhatsThisHelpID = nNewVal
End Property



' #############  Begin Events ###########################
Private Sub lstDragList_Click()
  RaiseEvent Click
End Sub

Private Sub lstDragList_DblClick()
  RaiseEvent DblClick
End Sub

Private Sub lstDragList_DragDrop(Source As Control, x As Single, y As Single)
  RaiseEvent LBDragDrop(Source, x, y)
End Sub

Private Sub lstDragList_DragOver(Source As Control, x As Single, y As Single, State As Integer)
  RaiseEvent LBDragOver(Source, x, y, State)
End Sub

Private Sub lstDragList_GotFocus()
  RaiseEvent LBGotFocus
End Sub

Private Sub lstDragList_KeyDown(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyDown(KeyCode, Shift)
End Sub

Private Sub lstDragList_KeyPress(KeyAscii As Integer)
  RaiseEvent KeyPress(KeyAscii)
End Sub

Private Sub lstDragList_KeyUp(KeyCode As Integer, Shift As Integer)
  RaiseEvent KeyUp(KeyCode, Shift)
End Sub

Private Sub lstDragList_LostFocus()
  RaiseEvent LBLostFocus
End Sub

Private Sub lstDragList_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseDown(Button, Shift, x, y)
End Sub

Private Sub lstDragList_MouseMove(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseMove(Button, Shift, x, y)
End Sub

Private Sub lstDragList_MouseUp(Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent MouseUp(Button, Shift, x, y)
End Sub

Private Sub lstDragList_OLECompleteDrag(Effect As Long)
  RaiseEvent OLECompleteDrag(Effect)
End Sub

Private Sub lstDragList_OLEDragDrop(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single)
  RaiseEvent OLEDragDrop(Data, Effect, Button, Shift, x, y)
End Sub

Private Sub lstDragList_OLEDragOver(Data As DataObject, Effect As Long, Button As Integer, Shift As Integer, x As Single, y As Single, State As Integer)
  RaiseEvent OLEDragOver(Data, Effect, Button, Shift, x, y, State)
End Sub

Private Sub lstDragList_OLEGiveFeedback(Effect As Long, DefaultCursors As Boolean)
  RaiseEvent OLEGiveFeedback(Effect, DefaultCursors)
End Sub

Private Sub lstDragList_OLESetData(Data As DataObject, DataFormat As Integer)
  RaiseEvent OLESetData(Data, DataFormat)
End Sub

Private Sub lstDragList_OLEStartDrag(Data As DataObject, AllowedEffects As Long)
  RaiseEvent OLEStartDrag(Data, AllowedEffects)
End Sub

Private Sub lstDragList_Scroll()
  RaiseEvent Scroll
End Sub


  'With lstDragList
    '.AddItem
    '.Appearance
    '.BackColor
    '.Clear
    '.Columns
    '.Container
    '.DataChanged
    '.Drag
    '.DragIcon
    '.DragMode
    '.Enabled
    '.Font
    '.FontBold
    '.FontItalic
    '.FontName
    '.FontSize
    '.FontStrikethru
    '.FontUnderline
    '.ForeColor
    '.Height
    '.HelpContextID
    '.hWnd
    '.Index
    '.IntegralHeight
    '.ItemData
    '.Left
    '.List
    '.ListCount
    '.ListIndex
    '.MouseIcon
    '.MousePointer
    '.Name
    '.NewIndex
    '.OLEDrag
    '.OLEDragMode
    '.OLEDropMode
    '.Parent
    '.RemoveItem
    '.RightToLeft
    '.SelCount
    '.Selected
    '.SetFocus
    '.ShowWhatsThis
    '.Sorted
    '.Style
    '.TabIndex
    '.TabStop
    '.Tag
    '.Text
    '.ToolTipText
    '.Top
    '.TopIndex
    '.Visible
    '.WhatsThisHelpID
    '.Width
    '.ZOrder
  'End With


