VERSION 5.00
Begin VB.Form frmTestDragList 
   AutoRedraw      =   -1  'True
   BorderStyle     =   4  'Fixed ToolWindow
   Caption         =   "Common Controls DragList"
   ClientHeight    =   1785
   ClientLeft      =   3210
   ClientTop       =   1530
   ClientWidth     =   6090
   Icon            =   "frmTestDragList.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   OLEDropMode     =   1  'Manual
   ScaleHeight     =   119
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   406
   Begin PDragList.UDragList UDragList1 
      Height          =   1380
      Left            =   180
      TabIndex        =   1
      Top             =   120
      Width           =   1830
      _ExtentX        =   3228
      _ExtentY        =   2434
   End
   Begin VB.Label Label1 
      Caption         =   $"frmTestDragList.frx":000C
      Height          =   1545
      Left            =   2175
      TabIndex        =   0
      Top             =   120
      Width           =   3750
   End
End
Attribute VB_Name = "frmTestDragList"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

  Option Explicit
  ' demo project showing how to turn a VB listbox into a DragList
  ' using the API functions in the common controls library.
  ' by Bryan Stafford of New Vision Software - newvision@mvps.org
  ' this demo is released into the public domain "as is" without
  ' warranty or guaranty of any kind.  In other words, use at
  ' your own risk.  See the comments in the UDragList module for
  ' important info about this project.

  Private m_bExtraItemAdded As Boolean

Private Sub Form_Load()
  
  ' add some stuff to the list
  With UDragList1
    .AddItem "Apple"
    .AddItem "Orange"
    .AddItem "Pear"
    .AddItem "Banana"
    .AddItem "Peach"
    .AddItem "Grape"
    .AddItem "Pomegranate"
    .AddItem "Lemon"
    .AddItem "Tangerine"
    .AddItem "Mango"
  End With
  
End Sub

Private Sub UDragList1_DLBeginDrag(ByVal iItem As Long, ByVal x As Long, ByVal y As Long, bCancel As Boolean)
  ' if the selected item isn't the last item in the list,
  ' add an extra "empty" item at the end of the list so that
  ' the dragged item can be dropped at the end of the list
  With UDragList1
    If .ListIndex < (.ListCount - 1) Then
      .AddItem "", .ListCount
      m_bExtraItemAdded = True
    End If
  End With
End Sub

Private Sub UDragList1_DLDragCanceled()
  ' if the extra item has been added, remove it...
  If m_bExtraItemAdded Then
    UDragList1.RemoveItem UDragList1.ListCount - 1
    m_bExtraItemAdded = False
  End If
End Sub

Private Sub UDragList1_DLDragging(ByVal iItem As Long, ByVal x As Long, ByVal y As Long, CursorType As DRAG_CURSOR_TYPE, bNoInsertIcon As Boolean)
  ' if the insert point is over the item that is being dragged,
  ' show the stop cursor.  otherwise, show the move cursor
  With UDragList1
    If (iItem = .ListIndex) Then  'Or ((.ListIndex = (.ListCount - 2))and (iitem=.lis))
      CursorType = DL_STOPCURSOR
    Else
      CursorType = DL_MOVECURSOR
    End If
  End With
End Sub

Private Sub UDragList1_DLDropped(ByVal iItem As Long, ByVal x As Long, ByVal y As Long)
  ' when an item is dropped, we have to do the actual moving of the item
  ' if you are using the itemdata property of each item in the list, you
  ' will need to add code to move that as well as it is not implemented here.
  
  Dim nOldIndex&, sItemText$
  
  With UDragList1
    If iItem > (-1) Then ' if this was and actual item, handle the move...
      nOldIndex = .ListIndex
        
      If iItem <> nOldIndex Then
        sItemText = .List(nOldIndex)
      
        If iItem < nOldIndex Then nOldIndex = nOldIndex + 1

        .AddItem sItemText, iItem
        .ListIndex = iItem
        .RemoveItem nOldIndex
      End If
    End If
  
    If m_bExtraItemAdded Then ' remove the extra item....
      .RemoveItem .ListCount - 1
      m_bExtraItemAdded = False
    End If
  End With

End Sub

Private Sub UDragList1_KeyDown(KeyCode As Integer, Shift As Integer)
  ' this is an implementation of keyboard moving.  if the shift key is pressed
  ' while the up or down arrow key is pressed, move the item in the appropriate
  ' direction.  if you are using the itemdata property of each item in the list,
  ' you will need to add code to move that as well as it is not implemented here.
  
  Dim nOldIndex&, sItemText$
  
  If Shift = 1 Then
    With UDragList1
      
      nOldIndex = .ListIndex
      
      Select Case KeyCode
        Case vbKeyUp
          If nOldIndex > 0 Then
            sItemText = .List(nOldIndex)
            
            .List(nOldIndex) = .List(nOldIndex - 1)
            .List(nOldIndex - 1) = sItemText
          End If
          
        Case vbKeyDown
          If (nOldIndex > (-1)) And (nOldIndex < (.ListCount - 1)) Then
            sItemText = .List(nOldIndex)
            
            .List(nOldIndex) = .List(nOldIndex + 1)
            .List(nOldIndex + 1) = sItemText
          End If
          
        
      End Select
    End With
  End If
  
End Sub









